/*****
 * Echo.c
 *
 *	SoundEditor: Copyright (c) 1993 by
 *
 *	Motion Works Corp.
 *	#130 - 1020 Mainland Street
 *	Vancouver, BC
 *	(604) 685-9975
 *
 *  Author:	DMS		(15SEP93)
 *
 *	echo sound effect (SE) component source for Marvin's Modulator
 *
 *****/

#include <MacHeaders>
#include <QuickTimeComponents.h>
#include <Sound.h>

#include "SoundEffect.h"

	// prototypes

pascal ComponentResult _SEDoEffect( Handle storage, SoundHeaderPtr soundHeader,
									Size selectionStart, Size selectionEnd,
									Handle *newSamples );

Boolean DoDialog( short *delay, short *strength );

ComponentResult DoEcho( short delay, short strength,
						SoundHeaderPtr soundHeader,
						Size selectionStart, Size selectionEnd,
						Handle *newSamples );


/***
 * _SEDoEffect
 *
 ***/

pascal ComponentResult _SEDoEffect( Handle storage, SoundHeaderPtr soundHeader,
									Size selectionStart, Size selectionEnd,
									Handle *newSamples )
{
	ComponentResult result = noErr;
	short			resFileRefNum;
	
	*newSamples = NULL;
	
	if ( ( resFileRefNum = OpenComponentResFile( ((PrivateGlobalsPtr)*storage)->self ) ) > 0 )
	{
		short delay, strength;

		if ( DoDialog( &delay, &strength ) )
			result = DoEcho( delay, strength,
								soundHeader, selectionStart, selectionEnd, newSamples );
		CloseComponentResFile( resFileRefNum );
	}
	else
	{
		result = resFileRefNum;
	}
		
	return result;
}



/***
 * DoEcho
 *
 ***/

ComponentResult DoEcho( short delay, short strength,
						SoundHeaderPtr soundHeader,
						Size selectionStart, Size selectionEnd,
						Handle *newSamples )
{
	ComponentResult result = noErr;
	register Size	totalBytes = selectionEnd - selectionStart;

	*newSamples = NewHandle( totalBytes );
	
	if ( *newSamples )
	{
		long double				seconds = delay / 1000.0;
		unsigned long			samples = 	(unsigned short)HiWord( soundHeader->sampleRate ) * seconds;	
		long double				percent = strength / 100.0;
		register unsigned char	*from, *to, *end;
		register short			newValue;
	
		HLock( *newSamples );
	
		BlockMove( soundHeader->sampleArea + selectionStart, **newSamples, totalBytes );

		from = (unsigned char*)**newSamples;
		to = from + samples;
		end = from + totalBytes;

		while ( to <= end )
		{
			newValue = *to - 128 + ( *from++ - 128 ) * percent;
			
			if 		( newValue < -128 )	newValue = -128;
			else if	( newValue > 127 ) 	newValue = 127;
			
			*to++ = newValue + 128;
		}
	
		HUnlock( *newSamples );	
	}
	else
	{
		*newSamples = NULL;
		result = MemError();
	}
	
	return result;
}
